<script setup lang="ts">
import { onClickOutside } from '@vueuse/core'
import { storeToRefs } from 'pinia'
import { useAccountStore } from '~~/store/account'
import { useChatStore } from '~~/store/chat'
import { useUIStore } from '~~/store/UI'

// Props
interface Message {
  message: string
  self: boolean
  ableToDelete: boolean
  sender: string
  id: string
  timeStamp: string
  pinned?: boolean
}

const {
  message,
  self,
  ableToDelete,
  sender,
  id,
  timeStamp,
  pinned = false,
} = defineProps<Message>()

const account = useAccountStore()
const { full } = storeToRefs(account)

// Action of store
const chat = useChatStore()
const remove = () => chat.removeChat(id)
const pin = () => chat.pinChat(id)

// Show Tool Toggle
const showTool = ref(false)
const target = ref(null)
onClickOutside(target, () => (showTool.value = false))
// Dialog Toggle
const removeDialog = ref(false)

// Popup
const el = ref(null)
const ui = useUIStore()
const {
  x,
  y,
  width,
  height,
  update,
} = useElementBounding(el)
const upToolBar = ref(false)

const updateMore = (arg: number) => {
  update()
  if (y.value + 110 > arg)
    upToolBar.value = true
  else
    upToolBar.value = false
}

defineExpose({ update: updateMore })
</script>

<template>
  <div ref="el" class="w-full flex gap-2 chatWrapper" :data-self="self">
    <div>
      <AAvatar :name="sender" class="" />
    </div>
    <div class="flex-1">
      <p class="opacity-70">
        {{ sender }} {{ new Date(timeStamp).toLocaleTimeString("it-IT") }}
      </p>
      <div class="text-lg message break-all">
        {{ message }}
      </div>
    </div>
    <div v-if="pinned" class="flex">
      <div class="flex items-center">
        <div class="i-bi:pin-fill" />
        <span>固定済み</span>
      </div>
      <div v-if="full" class="relative cursor-pointer p-2 my-auto bg-white dark:bg-neutral-900">
        <div class="i-bi:three-dots-vertical" @click="showTool = !showTool" />
        <div
          v-if="showTool"
          class="gap-1 border overflow-hidden absolute right-0 text-base bg-white dark:bg-neutral-900"
          :class="upToolBar ? 'bottom-full' : 'top-full'"
        >
          <button
            class="z-10 p-2 px-4 hover:bg-gray-300 dark:hover:bg-gray-700 w-full whitespace-nowrap"
            @click="() => chat.pinChat('')"
          >
            固定を解除する
          </button>
        </div>
      </div>
    </div>
    <div v-else ref="target" class="relative">
      <div
        v-if="ableToDelete || self"
        class="relative cursor-pointer p-2 my-auto bg-white dark:bg-neutral-900"
        @click="showTool = !showTool"
      >
        <div class="i-bi:three-dots-vertical" />
        <div
          v-if="showTool"
          class="gap-1 border overflow-hidden absolute z-100 right-0 text-base bg-white dark:bg-neutral-900"
          :class="upToolBar ? 'bottom-full' : 'top-full'"
        >
          <button
            class="p-2 px-4 hover:bg-gray-300 dark:hover:bg-gray-700 w-full whitespace-nowrap"
            @click="removeDialog = true"
          >
            削除する
          </button>
          <button
            v-if="ableToDelete"
            class="p-2 px-4 hover:bg-gray-300 dark:hover:bg-gray-700 whitespace-nowrap"
            @click="pin"
          >
            固定する
          </button>
        </div>
      </div>
    </div>
  </div>

  <AWarningModel
    v-if="removeDialog" text="削除しますか?"
    @close="removeDialog = false" @accept="remove"
  />
</template>

<style scoped>
.message {
  white-space: pre-line;
}
</style>
